/*
<p> Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 * @version 2.1 15.03.2014
 */


//Auf eine Fehlerbehandlung wurde bewusst verzichtet


import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JOptionPane;
import javax.swing.border.EmptyBorder;

public class UPNGui extends JFrame {

  private JPanel contentPane;
  private JTextField textField;
  private UPNStack derStack;
  private JLabel lblTop;

  /**
   * Launch the application.
   */
  public static void main(String[] args) {
    EventQueue.invokeLater(new Runnable() {
      public void run() {
        try {
          UPNGui frame = new UPNGui();
          frame.setVisible(true);
        } catch (Exception e) {
          e.printStackTrace();
        }
      }
    });
  }

  /**
   * Create the frame.
   */
  public UPNGui() {
    this.derStack = new UPNStack();
    setTitle("UPN-Rechner");
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setBounds(100, 100, 450, 300);
    contentPane = new JPanel();
    contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
    contentPane.setLayout(new BorderLayout(0, 0));
    setContentPane(contentPane);

    JPanel knoepfe = new JPanel();
    contentPane.add(knoepfe, BorderLayout.CENTER);

    JButton btnPlus = new JButton("Plus");
    btnPlus.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent arg0) {
        derStack.addieren();
        updateTop();
      }
    });
    knoepfe.add(btnPlus);

    JButton btnMinus = new JButton("Minus");
    btnMinus.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent arg0) {
        derStack.subtrahieren();
        updateTop();
      }
    });
    knoepfe.add(btnMinus);
    
    JButton btnMal = new JButton("Mal");
    btnMal.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent arg0) {
        derStack.multiplizieren();
        updateTop();
      }
    });
    knoepfe.add(btnMal);
    
    JButton btnDurch = new JButton("Durch");
    btnDurch.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent arg0) {
        derStack.dividieren();
        updateTop();
      }
    });
    knoepfe.add(btnDurch);
    
    JButton btnRest = new JButton("Rest");
    btnRest.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent arg0) {
        derStack.resten();
        updateTop();
      }
    });
    knoepfe.add(btnRest);

    JPanel panel = new JPanel();
    contentPane.add(panel, BorderLayout.SOUTH);

    textField = new JTextField();
    panel.add(textField);
    textField.setColumns(10);

    JButton btnEnter = new JButton("Enter");
    btnEnter.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent arg0) {
        entern();
      }
    });
    panel.add(btnEnter);

    JPanel panel_1 = new JPanel();
    contentPane.add(panel_1, BorderLayout.NORTH);

    lblTop = new JLabel("Top = ");
    panel_1.add(lblTop);
  }

  private void updateTop() {
        String topString = "";
    String error = null;
    int top = this.derStack.erstes();
    topString = "" + top;
    this.lblTop.setText("Top = " + topString);
    
   }   

  private void entern() {
    String operandString = this.textField.getText();
    this.textField.setText("");
    Integer operand = new Integer (Integer.valueOf(operandString));
    boolean fehler=false;
    this.derStack.enter(operand);
      updateTop();
  }

}
