 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2014-03-13
 */


public class UPNStack {

  private Stack<Integer> operanden;    // Mit der NRW-Klasse List

  /**
   * 
   */
  public UPNStack() {
    this.operanden = new Stack<Integer>();
  }

  public void enter(Integer zahl) {
    this.operanden.push(zahl);
  }

  
  public int erstes()  {
      return this.operanden.top();
  }

  private void operiere(int operator)  {
      Integer ergebnis=0;
      Integer zweiter = this.operanden.top();
    operanden.pop();
      Integer erster = this.operanden.top();
    operanden.pop();
    switch (operator) {
      case 1:
      ergebnis = erster + zweiter;
      break;
      case 2:
      ergebnis = erster - zweiter;
      break;
      case 3:
      ergebnis = erster * zweiter;
      break;
      case 4:
        ergebnis = erster / zweiter;
        break;
      case 5:
          ergebnis = erster % zweiter;
      break;
      }
      this.operanden.push(ergebnis);
  }

  public void addieren() {
    operiere(1);
  }

  public void subtrahieren() {
    operiere(2);
  }

  public void multiplizieren() {
    operiere(3);
  }

  public void dividieren()  {
    operiere(4);
  }

  public void resten() {
    operiere(5);
  }
}
